Subject: bug#60127: treesit-end-of-defun: possible bug with clojure grammar

From: Yuan Fu <[email-masked]>
Date: Thu, 22 Dec 2022 00:55:38 -0800

Danny Freeman <[email-masked]> writes:

> Yuan,
>
>>> Thank you very much for this detailed report! This seems to be some
>>> problem with either tree-sitter or tree-sitter-clojure, where
>>> treesit-node-first-child-for-pos gives wrong result. We’ve had similar
>>> problem with bash before[1].
>>>
>>> At this point there aren’t much we can do in Emacs. If I find some time
>>> I’ll make a reproduce recipe and submit an issue on tree-sitter-clojure.
>>>
>>> [1] https://github.com/tree-sitter/tree-sitter-bash/issues/139
>>>
>>> Yuan
>
> I have a c program that I believe reproduces the problem. I'm not sure
> how we will go about fixing it in tree-sitter-clojure, but at least we
> have a minimal way to re-create it.
>
> Here is a link to the issue I created:
> https://github.com/sogaiu/tree-sitter-clojure/issues/32
> that also includes the c-program. I've also put it on my source hut
> https://paste.sr.ht/~dannyfreeman/8786059276c334036877159a5b0872cd2aa6fbc0 
>
> If you find the time, I would appreciate it if you could confirm my
> findings. I'm a little in over my head with this bug I'm afraid.

I think it’s pretty good (the reproduce), the author’s modified program
is even better. Let’s wait and see what tree-sitter’s author have to
say.

Yuan